/*******************************************************************
** File        : SX1212driver.c                                   **
********************************************************************
**                                                                **
** Version     : V 1.0                                            **
**                                                                **
** Written by  : Chaouki ROUAISSIA                                **
** Edited by   : Florian KELLER                                   **
**                                                                **
** Date        : 18-08-2009                                       **
**                                                                **
** Project     : API-1212                                         **
**                                                                **
********************************************************************

********************************************************************
** Description : SX1212 transceiver drivers implementation for the**
**               XE8000 family products !!! Packet mode !!!       **
*******************************************************************/

/*******************************************************************
** Include files                                                  **
*******************************************************************/
#include "SX1212Driver.h"
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */

#define BASE_FERQ  14400  /* 1000*12.8*9/8 Page:16; 12.8ǾƵʵλMHZ */
/*  ֵʱҪ޸ĵĺ궨    */	
#define IRQP_0    (1ul << 4)                                           /* ģж             */
#define IRQP_1    (1ul << 1)                                           /* ģж             */
#define SEL_C_PIN (1ul << 3)                                           /* SPIƬѡţòʱʹ  */
#define SEL_D_PIN (1ul << 2)                                           /* SPIƬѡţдշ    */

#define SDO_PIN   (1ul << 8)                                           /* ģSPIţ            */
#define CLK_PIN   (1ul << 6)                                           /* SPIʱӣƵʲҪ5MHz    */
#define SDI_PIN   (1ul << 9)                                           /* ģSPI              */

#define SEL_D_L()      LPC_GPIO0->DATA &= ~SEL_D_PIN
#define SEL_D_H()      LPC_GPIO0->DATA |=  SEL_D_PIN 

#define SEL_C_L()      LPC_GPIO0->DATA &= ~SEL_C_PIN 
#define SEL_C_H()      LPC_GPIO0->DATA |=  SEL_C_PIN 

#define SDI_L()        LPC_GPIO0->DATA &= ~SDI_PIN
#define SDI_H()        LPC_GPIO0->DATA |=  SDI_PIN   

#define CLK_L()        LPC_GPIO0->DATA &= ~CLK_PIN 
#define CLK_H()        LPC_GPIO0->DATA |=  CLK_PIN  

#define SDO_READ()     ((LPC_GPIO0->DATA & SDO_PIN) != 0)

#define IRQPIN_0()     ((LPC_GPIO0->DATA & IRQP_0) != 0)           /* ȡģж״̬     */
#define IRQPIN_1()     ((LPC_GPIO2->DATA & IRQP_1) != 0)           /* ȡģж״̬     */

_U8  true  = 1;
_U8  false = 0;
/* ڿSPIʣݲͬMCUٶǰΪMCUƵΪ48MHz    */
#define TIME   1 
/*******************************************************************
** Global variables                                               **
*******************************************************************/
static   _U8 RFState = RF_STOP;     // RF state machine
static   _U8 *pRFFrame;             // Pointer to the RF frame
static   _U8 RFFramePos;            // RF payload current position
static   _U8 RFFrameSize;           // RF payload size
static  _U16 ByteCounter = 0;       // RF frame byte counter
static   _U8 PreMode = RF_STANDBY;  // Previous chip operating mode
static   _U8 SyncSize = 4;          // Size of sync word
static   _U8 SyncValue[4];       // Value of sync word
static  _U32 RFFrameTimeOut = RF_FRAME_TIMEOUT(1600); // Reception counter value (full frame timeout generation)


_U16 RegistersCfg[] = { // SX1212 configuration registers values
	//0 :״̬ƵʷΧ
	DEF_MCPARAM1 | RF_MC1_STANDBY | RF_MC1_BAND_430470 | RF_MC1_SUBBAND_FIRST,              
	//1 :ģʽģʽIF
	DEF_MCPARAM2 | RF_MC2_DATA_MODE_PACKET | RF_MC2_MODULATION_FSK | RF_MC2_OOK_THRESH_TYPE_PEAK | RF_MC2_GAIN_IF_00,               
	//2 :Ƶƫ
	DEF_FDEV | RF_FDEV_50,
	//3 :д
	DEF_BITRATE_MSB | RF_BITRATE_MSB_25000,
	//4 :д
	DEF_BITRATE_LSB | RF_BITRATE_LSB_25000,
	//5 :
	DEF_MCPARAM6 | RF_MC6_PARAMP_11 | RF_MC6_LOW_POWER_RX_OFF | RF_MC6_VCO_TRIM_11 | RF_MC6_RPS_SELECT_1,
	//6 :PLLƵĴ1  433Mhz
	DEF_R1 | 0x8f,                          
	//7 :PLLƵĴ1  433Mhz
	DEF_P1 | 0x38,                           
	//8 :PLLƵĴ1  433Mhz
	DEF_S1 | 0x37,                          
	//9 :PLLƵĴ2
	DEF_R2 | RF_R2_VALUE,                            
	//10:PLLƵĴ2
	DEF_P2 | RF_P2_VALUE,                            
	//11:PLLƵĴ2
	DEF_S2 | RF_S2_VALUE,                         
	//12:FIFOȣFIFO
	DEF_FIFOCONFIG | RF_FIFO_SIZE_64 | RF_FIFO_THRESH_VALUE,
	//13:IRQ0IRQ1жԴ
	DEF_IRQPARAM1 | RF_IRQ0_RX_STDBY_PAYLOADREADY | RF_IRQ1_RX_STDBY_CRCOK | RF_IRQ0_TX_FIFOEMPTY_START_FIFONOTEMPTY | RF_IRQ1_TX_TXDONE,             
	//14:FIFI Tx_Done RSSI_irq PLL_lock
	DEF_IRQPARAM2 | RF_IRQ2_PLL_LOCK_PIN_ON,              
	//15:źǿż
	DEF_RSSIIRQTHRESH | RF_RSSIIRQTHRESH_VALUE,             
	//16:˲BW
	DEF_RXPARAM1 | RF_RX1_PASSIVEFILT_378 | RF_RX1_FC_FOPLUS100,       
	//17:Ƶ˲ 
	DEF_RXPARAM2 | RF_RX2_FO_100,                   
	//18:ͬص 
	DEF_RXPARAM3 | RF_RX3_POLYPFILT_OFF | RF_RX3_SYNC_SIZE_32 | RF_RX3_SYNC_TOL_0,             
	//19:OOK
	DEF_OOKFLOORTHRESH | RF_OOKFLOORTHRESH_VALUE,                    
    //20:RSSIźǿȣֻĴ            
	DEF_RSSIVALUE,
	//21:OOK 
	DEF_RXPARAM6 | RF_RX6_OOK_THRESH_DECSTEP_000 | RF_RX6_OOK_THRESH_DECPERIOD_000 | RF_RX6_OOK_THRESH_AVERAGING_00,                    
	//22:ͬ1
	DEF_SYNCBYTE1 | 0x69, // 1st byte of Sync word,                    
	//23:ͬ2
	DEF_SYNCBYTE2 | 0x81, // 2nd byte of Sync word,                     
	//24:ͬ3
	DEF_SYNCBYTE3 | 0x7E, // 3rd byte of Sync word,                     
	//25:ͬ4
	DEF_SYNCBYTE4 | 0x96, // 4th byte of Sync word,                     
	//26:˲ 
	DEF_TXPARAM | RF_TX_FC_200 | RF_TX_POWER_MAX | RF_TX_ZERO_IF_OFF,                    
	//27:CLK 
	DEF_OSCPARAM | RF_OSC_CLKOUT_ON | RF_OSC_CLKOUT_427,                 
	//28:ȣʽ 
	DEF_PKTPARAM1 | RF_PKT1_MANCHESTER_OFF | 64,               
	//29:ַ 
	DEF_NODEADRS  | RF_NODEADRS_VALUE, 
	//30:ʽ볤ȣCRCַ˽ʹ 
	DEF_PKTPARAM3 | RF_PKT3_FORMAT_VARIABLE | RF_PKT3_PREAMBLE_SIZE_32 | RF_PKT3_WHITENING_OFF | RF_PKT3_CRC_ON | RF_PKT3_ADRSFILT_00,             
	//31:standbyģʽʱѡFIFOɶǿд 
	DEF_PKTPARAM4 | RF_PKT4_AUTOCLEAR_ON | RF_PKT4_FIFO_STANDBY_WRITE
   
};

/*******************************************************************
** Configuration functions                                        **
*******************************************************************/
void SPIInit( void )
{
	SEL_C_H();
	
	LPC_GPIO0->DIR    = 0x26c;                                          /* ZM470SX                  */

	LPC_GPIO1->DIR    |= 0x800;                                          
	LPC_GPIO2->DIR    &= 0xff0;	
	LPC_GPIO2->DIR    &= 0xffb;                                         /* ZM470S,SPI           */
	LPC_GPIO3->DIR    &= 0xf7;                                          /* ZM470S,IRQ1:PIO3_3       */
	
    LPC_GPIO2->DATA   &= ~(1ul << 1);                                    /* CLK1̬Ϊ͵ƽ            */
    LPC_GPIO2->DATA   &= ~(1ul << 2);                                    /* SDO1̬Ϊ͵ƽ            */
	
    LPC_GPIO0->DATA   &= ~(1ul << 6);                                    /* CLK̬Ϊ͵ƽ             */
    LPC_GPIO0->DATA   &= ~(1ul << 8);                                    /* SDI̬Ϊ͵ƽ             */

}
/*********************************************************************************************************
** Function name:        IRQ1_READ
** Descriptions:         ȡж1ŵĵƽ
** input parameters:     
** output parameters:    
*********************************************************************************************************/
_U8 IRQ1_READ(void)
{
    return IRQPIN_1();
}
/*********************************************************************************************************
** Function name:        dellay
** Descriptions:         ʱһСʱ
** input parameters:     i 
** output parameters:    
*********************************************************************************************************/
void dellayus(unsigned int i)
{
	unsigned int j,k;
   
	for (j = 0; j <1; j++){
		for (k = 0; k < i; k++);
	}
}
/*********************************************************************************************************
** Function name:       SpiSendByte
** Descriptions:        Ϸһֽ
** input parameters:    senddata:Ҫ͵
** output parameters:   
*********************************************************************************************************/
void SpiInOut(unsigned char senddata)
{
    unsigned char i;
    
    for(i=0;i<8;i++)
    {
		dellayus(TIME);
        CLK_L();                                                        /* clk=0;                       */
        if((senddata<<i)&0x80){
			dellayus(TIME);
            SDI_H();                                                    /* set 1;                       */
		} else {
			dellayus(TIME);	
            SDI_L();                                                    /* set 0;                       */
        } 
		dellayus(TIME);	
		CLK_H();                                                        /* clk=1;                       */
    }
    dellayus(TIME);  
	CLK_L();
	SDI_L();                                                            /* set 0;                       */ 
}
/*********************************************************************************************************
** Function name:       SpiRCVByte
** Descriptions:        Ͻһֽ
** input parameters:    
** output parameters:   
*********************************************************************************************************/
unsigned char SpiRCVaByte(void)
{
    unsigned char i,temp;
    temp = 0;
    for(i=0;i<8;i++)
    {
		
        CLK_L();                                                        /* clk=0;                       */
        dellayus(TIME);   
		temp=(temp<<1);
        CLK_H();                                                         /* clk=1;                       */
                    dellayus(TIME); 
			if(SDO_READ())
            temp++;                                                     /* set 1;                       */
        else
            temp = temp+0;
		dellayus(TIME); 
    }
    CLK_L();
	dellayus(TIME);
    return temp;
}


void SX1276WriteBuffer( uint8_t addr, uint8_t *buffer, uint8_t size )
{
    uint8_t i;

    //NSS = 0;
	//GPIO_WriteBit( NSS_IOPORT, NSS_PIN, Bit_RESET );
    SEL_C_L();

    SpiInOut( addr | 0x80 );
    for( i = 0; i < size; i++ )
    {
        SpiInOut( buffer[i] );
    }

    //NSS = 1;
    //GPIO_WriteBit( NSS_IOPORT, NSS_PIN, Bit_SET );
    SEL_C_H();
}

void SX1276ReadBuffer( uint8_t addr, uint8_t *buffer, uint8_t size )
{
    uint8_t i;

    //NSS = 0;
	//GPIO_WriteBit( NSS_IOPORT, NSS_PIN, Bit_RESET );
    SEL_C_L();

    SpiInOut( addr & 0x7F );

    for( i = 0; i < size; i++ )
    {
        buffer[i] = SpiRCVaByte();
    }

    //NSS = 1;
    //GPIO_WriteBit( NSS_IOPORT, NSS_PIN, Bit_SET );
    SEL_C_H();
}


//#if 1
void SX1276Write( uint8_t addr, uint8_t data )
{
    SX1276WriteBuffer( addr, &data, 1 );
}

void SX1276Read( uint8_t addr, uint8_t *data )
{
    SX1276ReadBuffer( addr, data, 1 );
}

/*******************************************************************
** InitRFChip : This routine initializes the RFChip registers     **
**              Using Pre Initialized variables                   **
********************************************************************
** In  : -                                                        **
** Out : -                                                        **
*******************************************************************/
void InitRFChip (void){
    _U16 i;
    //Initializes SX1212
    SPIInit();
	//set_bit(PORTO, (SCK + NSS_DATA + NSS_CONFIG + MOSI));
	//set_bit(PORTP, (SCK + NSS_DATA + NSS_CONFIG + MOSI));

    for(i = 0; (i + 1) <= REG_PKTPARAM4; i++){
        if(i < REG_RSSIVALUE){
            WriteRegister(i, RegistersCfg[i]);
        }
        else{
			//WriteRegister(i, RegistersCfg[i]);
            WriteRegister(i + 1, RegistersCfg[i+1]);
        }
    }

    SyncSize = ((RegistersCfg[REG_RXPARAM3] >> 3) & 0x03) + 1;
    for(i = 0; i < SyncSize; i++){
        SyncValue[i] = RegistersCfg[REG_SYNCBYTE1 + i];
    }

    if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_1600) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_1600)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(1600);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_2000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_2000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(2000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_2500) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_2500)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(2500);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_5000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_5000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(5000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_5000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_5000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(8000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_10000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_10000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(10000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_20000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_20000)){    
        RFFrameTimeOut = RF_FRAME_TIMEOUT(20000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_25000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_25000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(25000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_40000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_40000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(40000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_50000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_50000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(50000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_100000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_100000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(100000);
    }
    else if((RegistersCfg[REG_BITRATE_MSB] == RF_BITRATE_MSB_200000) && (RegistersCfg[REG_BITRATE_LSB] == RF_BITRATE_LSB_200000)){
        RFFrameTimeOut = RF_FRAME_TIMEOUT(200000);
    }
    else {
        RFFrameTimeOut = RF_FRAME_TIMEOUT(1600);
    }

    SetRFMode(RF_SLEEP);
	//SetRFMode(RF_RECEIVER);
}

/*******************************************************************
** SetRFMode : Sets the SX1212 operating mode                     **
********************************************************************
** In  : mode                                                     **
** Out : -                                                        **
*******************************************************************/
void SetRFMode(_U8 mode){
    if(mode != PreMode){
        if(mode == RF_TRANSMITTER){
        	if (PreMode == RF_SLEEP){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_STANDBY);        		
			   Wait(TS_OS);        		
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
			   Wait(TS_FS);         		
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_TRANSMITTER);
			   Wait(TS_TR);
        	}
			else if (PreMode == RF_STANDBY){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
			   Wait(TS_FS);         		
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_TRANSMITTER);
			   Wait(TS_TR);
			}

			else if (PreMode == RF_SYNTHESIZER){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_TRANSMITTER);
			   Wait(TS_TR);
			}

			else if (PreMode == RF_RECEIVER){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_TRANSMITTER);
			   Wait(TS_TR);
			}		        
			PreMode = RF_TRANSMITTER;
        }
        
        else if(mode == RF_RECEIVER){
        
			if (PreMode == RF_SLEEP){
				WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_STANDBY);        		
				Wait(TS_OS);        		
				WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
				Wait(TS_FS); 
				WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_RECEIVER);
				Wait(TS_RE);
			}

			else if (PreMode == RF_STANDBY){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
			   Wait(TS_FS); 
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_RECEIVER);
			   Wait(TS_RE);
			}

			else if (PreMode == RF_SYNTHESIZER){
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_RECEIVER);
			   Wait(TS_RE);     		
			}

			else if (PreMode == RF_TRANSMITTER){	
			   WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_RECEIVER);
			   Wait(TS_RE);
			}
			PreMode = RF_RECEIVER;
        }
        
        else if(mode == RF_SYNTHESIZER){
        
            if (PreMode == RF_SLEEP){
	            WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_STANDBY);        		
        		   Wait(TS_OS);        		
	            WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
        		   Wait(TS_FS); 
        	}

        	else if (PreMode == RF_STANDBY){
        	    WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
        		Wait(TS_FS); 
        	}

        	else {
        	    WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SYNTHESIZER);        		
        	}
            
            PreMode = RF_SYNTHESIZER;
        }
        
        else if(mode == RF_STANDBY){
        
            if (PreMode == RF_SLEEP){
	            WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_STANDBY);        		
        		Wait(TS_OS);
        	}

        	else {
	            WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_STANDBY);       		
        	}
        		
        	PreMode = RF_STANDBY;
        }
        
        else {
			// mode == RF_SLEEP
			WriteRegister(REG_MCPARAM1, (RegistersCfg[REG_MCPARAM1] & 0x1F) | RF_SLEEP);
			PreMode = RF_SLEEP;
        }
    }
}

/*******************************************************************
** WriteRegister : Writes the register value at the given address **
**                  on the SX1212                                 **
********************************************************************
** In  : address, value                                           **
** Out : -                                                        **
*******************************************************************/
void WriteRegister(_U8 address, _U8 value){ //ԭ:_U16 valueĳ_U8 valueܻ    
    
    address = (address << 1) & 0x3E ;
    SX1276WriteBuffer( address, &value, 1 );
}

/*******************************************************************
** ReadRegister : Reads the register value at the given address on**
**                the SX1212                                      **
********************************************************************
** In  : address                                                  **
** Out : value                                                    **
*******************************************************************/
_U16 ReadRegister(_U8 address){
    _U8 value = 0;

    address = ((address << 1) & 0x7E) | 0x40;
    SX1276ReadBuffer( address, &value, 1 );
    return value;
}

/*******************************************************************
** Communication functions                                        **
*******************************************************************/

/*******************************************************************
** SendRfFrame : Sends a RF frame                                 **
********************************************************************
** In  : *buffer, size                                            **
** Out : *pReturnCode                                             **
*******************************************************************/
void SendRfFrame(_U8 *buffer, _U8 size, _U8 *pReturnCode){
    if((size+1) > (((RegistersCfg[REG_FIFOCONFIG])>>6)+1)*16){  // If (size + length byte) > FIFO size
        RFState |= RF_STOP;
        *pReturnCode = ERROR;
        return;
    }

    RFState |= RF_BUSY;
    RFState &= ~RF_STOP;
    RFFrameSize = size;
    pRFFrame = buffer;
    
    SetRFMode(RF_STANDBY);
	//FIFO access in standby mode
    WriteRegister(REG_PKTPARAM4, (RegistersCfg[REG_PKTPARAM4] & 0xBF) | RF_PKT4_FIFO_STANDBY_WRITE);
    
    SendByte(RFFrameSize);
    for(ByteCounter = 0, RFFramePos = 0; ByteCounter < RFFrameSize;){
		SendByte(pRFFrame[RFFramePos++]); 
		ByteCounter++; 
    }

    SetRFMode(RF_TRANSMITTER); // Cf RF_IRQ0_TX_FIFOEMPTY_START_FIFONOTEMPTY in RegistersConfig 
    
    do{
    }while(!(IRQPIN_1())); // Wait for TX done. Cf RF_IRQ1_TX_TXDONE in RegistersConfig
    Wait(1000); // Wait for last bit to be sent (worst case bitrate)

    //SetRFMode(RF_SLEEP);
    SetRFMode(RF_STANDBY);


    RFState |= RF_STOP;
    RFState &= ~RF_TX_DONE;
    *pReturnCode = OK;
} // void SendRfFrame(_U8 *buffer, _U8 size, _U8 *pReturnCode)

/*******************************************************************
** ReceiveRfFrame : Receives a RF frame                           **
********************************************************************
** In  : -                                                        **
** Out : *buffer, size, *pReturnCode                              **
*******************************************************************/
void ReceiveRfFrame(_U8 *buffer, _U8 *size, _U8 *pReturnCode){
    
	_U8 TempRFState;

	*pReturnCode = RX_RUNNING;
	pRFFrame = buffer;
	TempRFState = RF_RX_DONE;//RFState; 

	if(TempRFState & RF_STOP){
        pRFFrame = buffer;
        RFFramePos = 0;
        RFFrameSize = 2;
                
		//RegIrqEnMid |= 0x02; // Enables Port A pin 1 interrupt IRQ_1 (CRCOK, Cf RF_IRQ1_RX_STDBY_CRCOK in RegistersConfig)

        SetRFMode(RF_RECEIVER);
        EnableTimeOut(true);
        RFState |= RF_BUSY;
        RFState &= ~RF_STOP;
        RFState &= ~RF_TIMEOUT;
        return;
    }
    else if(TempRFState & RF_RX_DONE){

        SetRFMode(RF_STANDBY);        
        WriteRegister(REG_PKTPARAM4, (RegistersCfg[REG_PKTPARAM4] & 0xBF) | RF_PKT4_FIFO_STANDBY_READ);
            
        RFFrameSize = ReceiveByte();
        for(ByteCounter = 0, RFFramePos = 0; ByteCounter < RFFrameSize; ){
			pRFFrame[RFFramePos++] = ReceiveByte();
            ByteCounter++; 
        }
        //SetRFMode(RF_SLEEP);
        
        *size = RFFrameSize;
        *pReturnCode = OK;
        RFState |= RF_STOP;
        EnableTimeOut(false);
        RFState &= ~RF_RX_DONE;
		//RegIrqEnMid &= ~0x02; // Disables Port A pin 1 interrupt IRQ_1 (CRCOK, Cf RF_IRQ1_RX_STDBY_CRCOK in RegistersConfig)
        SEL_D_H();  //SPINssData(1);
        return;
    }
    else if(TempRFState & RF_ERROR){
        RFState |= RF_STOP;
        RFState &= ~RF_ERROR;
        *pReturnCode = ERROR;
		//RegIrqEnMid &= ~0x02; // Disables Port A pin 1 interrupt IRQ_1 (CRCOK, Cf RF_IRQ1_RX_STDBY_CRCOK in RegistersConfig)
        SEL_D_H();   //SPINssData(1);
        return;
    }
    else if(TempRFState & RF_TIMEOUT){
        RFState |= RF_STOP;
        RFState &= ~RF_TIMEOUT;
        EnableTimeOut(false);
        *pReturnCode = RX_TIMEOUT;
		//RegIrqEnMid &= ~0x02; // Disables Port A pin 1 interrupt IRQ_1 (CRCOK, Cf RF_IRQ1_RX_STDBY_CRCOK in RegistersConfig)
        SEL_D_H();  //SPINssData(1);
        return;
    }
} // void ReceiveRfFrame(_U8 *buffer, _U8 size, _U8 *pReturnCode)

/*******************************************************************
** SendByte : Sends a data to the transceiver trough the SPI      **
**            interface                                           **
********************************************************************
** In  : b                                                        **
** Out : -                                                        **
*******************************************************************/
/*******************************************************************
**  Information                                                   **
********************************************************************
** This function has been optimized to send a byte to the         **
** transceiver SPI interface as quick as possible by using        **
** IO ports.                                                      **
** If the microcontroller has an  SPI hardware interface there is **
** no need to optimize the function                               **
*******************************************************************/
void SendByte(_U8 b){

	SEL_C_H(); 
    SEL_D_L();
    SpiInOut( b );
    SEL_D_H();

} // void SendByte(_U8 b)

/*******************************************************************
** ReceiveByte : Receives a data from the transceiver trough the  **
**               SPI interface                                    **                                                
********************************************************************
** In  : -                                                        **
** Out : b                                                        **
*******************************************************************/
/*******************************************************************
**  Information                                                   **
********************************************************************
** This function has been optimized to receive a byte from the    **
** transceiver SPI interface as quick as possible by using        **
** IO ports.                                                      **
** If the microcontroller has an  SPI hardware interface there is **
** no need to optimize the function                               **
*******************************************************************/
_U8 ReceiveByte(void){
    _U8 inputByte = 0;

	SEL_C_H(); 
    SEL_D_L();
    inputByte = SpiRCVaByte();
    SEL_D_H();

	return inputByte;
}
/*******************************************************************
** Transceiver specific functions                                 **
*******************************************************************/

/*******************************************************************
** ReadRssi : Reads the Rssi value from the SX1212                **
********************************************************************
** In  : -                                                        **
** Out : value                                                    **
*******************************************************************/
_U16 ReadRssi(void){
	_U16 value;
	value = ReadRegister(REG_RSSIVALUE);  // Reads the RSSI result
	return value;
}

/*******************************************************************
** Utility functions                                              **
*******************************************************************/

/*******************************************************************
** Wait : This routine uses the counter A&B to create a delay     **
**        using the RC ck source                                  **
********************************************************************
** In   : cntVal                                                  **
** Out  : -                                                       **
*******************************************************************/
void Wait(_U16 cntVal){
	 dellayus(cntVal);
} // void Wait(_U16 cntVal)
/*******************************************************************
** EnableTimeOut : Enables/Disables the RF frame timeout          **
********************************************************************
** In  : enable                                                   **
** Out : -                                                        **
*******************************************************************/
void EnableTimeOut(_U8 enable){
//    RegCntCtrlCk = (RegCntCtrlCk & 0xFC) | 0x03;        // Selects 128 Hz frequency as clock source for counter A&B
//    RegCntConfig1 |=  0x34;                             // A&B counters count up, counter A&B  are in cascade mode
//
//    RegCntA = (_U8)RFFrameTimeOut;                      // LSB of RFFrameTimeOut
//    RegCntB = (_U8)(RFFrameTimeOut >> 8);               // MSB of RFFrameTimeOut
//
//    if(enable){
//        RegIrqEnHig |= 0x10;                            // Enables IRQ for the counter A&B
//        RegCntOn |= 0x03;                               // Enables counter A&B
//    }
//    else{
//        RegIrqEnHig &= ~0x10;                           // Disables IRQ for the counter A&B
//        RegCntOn &= ~0x03;                              // Disables counter A&B
//    }
;
} // void EnableTimeOut(_U8 enable)


/*******************************************************************
** SX1212 Packet interrupt handlers                             **
*******************************************************************/

/*******************************************************************
** Handle_Irq_Pa1 : Handles the interruption from the Pin 1 of    **
**                  Port A                                        **
********************************************************************
** In  : -                                                        **
** Out : -                                                        **
*******************************************************************/
void Handle_Irq_Pa1 (void){ // IRQ_1 = CRC_OK , Cf RF_IRQ1_RX_STDBY_CRCOK in RegistersConfig (Irq routine only used in Rx)
 
     RFState |= RF_RX_DONE;
     RFState &= ~RF_BUSY;
        
} //End Handle_Irq_Pa1

/*******************************************************************
** Handle_Irq_Pa2 : Handles the interruption from the Pin 2 of    **
**                  Port A                                        **
********************************************************************
** In  : -                                                        **
** Out : -                                                        **
*******************************************************************/
void Handle_Irq_Pa2 (void){ // IRQ_0 


} //End Handle_Irq_Pa2

/*******************************************************************
** Handle_Irq_CntA : Handles the interruption from the Counter A  **
********************************************************************
** In              : -                                            **
** Out             : -                                            **
*******************************************************************/
void Handle_Irq_CntA (void){
    RFState |= RF_TIMEOUT;
    RFState &= ~RF_BUSY;
} //End Handle_Irq_CntA
/*********************************************************************************************************
** Function name:       Freq_Set
** Descriptions:        زƵ
** input parameters:    Χ:390000KHz ~ 510000KHz;
** output parameters:   
** Returned value:      
*********************************************************************************************************/
unsigned int Freq_Set (double freq)
{
	double freqtemp,freqPreMin,freqCurMin;
	unsigned char ucR,ucP,ucS;
    unsigned char ucSetBuf[3];
	//unsigned char ucSetNearest[3];

	if((389999 < freq) && (freq < 430001 )) {
	    ucSetBuf[0] = DEF_MCPARAM1 | RF_MC1_STANDBY | RF_MC1_BAND_390430 | RF_MC1_SUBBAND_FIRST,    /*  0:״̬ƵʷΧ  */  
        WriteRegister(0,ucSetBuf[0]);
	}else 	if((430000 < freq) && (freq < 470001 )) {
	    ucSetBuf[0] = DEF_MCPARAM1 | RF_MC1_STANDBY | RF_MC1_BAND_430470 | RF_MC1_SUBBAND_FIRST,    /*  0:״̬ƵʷΧ  */  
        WriteRegister(0,ucSetBuf[0]);
	}else if((470000 < freq) && (freq < 510001 )) {
	    ucSetBuf[0] = DEF_MCPARAM1 | RF_MC1_STANDBY | RF_MC1_BAND_470510 | RF_MC1_SUBBAND_FIRST,    /*  0:״̬ƵʷΧ  */  
        WriteRegister(0,ucSetBuf[0]);
	} else {
		return 0;
	}

	/* ͬƵʶӦļĴֵ */
	if(freq == 425000)
	{
		ucSetBuf[0] = 0x47;
		ucSetBuf[1] = 0x1b;
		ucSetBuf[2] = 0x19;
	}
	else if(freq == 430000)
	{
		ucSetBuf[0] = 0x6b;
		ucSetBuf[1] = 0x2a;
		ucSetBuf[2] = 0x00;
	}
	else if(freq == 433000)
	{
		ucSetBuf[0] = 0x8f;
		ucSetBuf[1] = 0x38;
		ucSetBuf[2] = 0x37;
	}
	else if(freq == 440000)
	{
		ucSetBuf[0] = 0x47;
		ucSetBuf[1] = 0x1c;
		ucSetBuf[2] = 0x19;
	}
	else if(freq == 465000)
	{
		ucSetBuf[0] = 0x47;
		ucSetBuf[1] = 0x1e;
		ucSetBuf[2] = 0x0;
	}
	else if(freq == 470000)
	{
		ucSetBuf[0] = 0x47;
		ucSetBuf[1] = 0x1e;
		ucSetBuf[2] = 0x19;
	}
	else
	{
		/* õƵʲгķΧڣʹö
		ϵķʽ׼ȷƵʣ̴Լ1 */
		freqPreMin =  510000;
		for(ucR = 65; ucR < 169; ucR++) {        // 64 =< R =< 169
			for(ucP = 5; ucP < 150; ucP++) {
				for(ucS = 0; ucS < ucP + 1;ucS++) {	 //  S < P + 1 
					freqtemp = BASE_FERQ	* (75 * (ucP + 1) + ucS) / (ucR + 1);	 // Ƶʼ㹫ʽ,ֲĵ16ҳ,KHzΪλ 
					if(freqtemp < freq)  {
						freqCurMin = freq - freqtemp;
					}else {
						freqCurMin = freqtemp - freq;
					}
					if(freqCurMin < freqPreMin) {
						freqPreMin = freqCurMin;
						ucSetBuf[0] = ucR;
						ucSetBuf[1] = ucP;
						ucSetBuf[2] = ucS;
					}
				}
			} 
		}
	}
	WriteRegister(6,ucSetBuf[0]);                 
	WriteRegister(7,ucSetBuf[1]);                        
	WriteRegister(8,ucSetBuf[2]);
	freqtemp = (12800*9/8)*(75*ucSetBuf[1] + ucSetBuf[2])/(ucSetBuf[0] + 1); 
	return freqtemp;
}

